unit lettres;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, DBCtrls, ComCtrls, RXSpin, Spin;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    Edit2: TEdit;
    Button8: TButton;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Quitte1: TMenuItem;
    importe1: TMenuItem;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    ProgressBar2: TProgressBar;
    Label3: TLabel;
    SpinEdit1: TSpinEdit;
    Aide1: TMenuItem;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button8Click(Sender: TObject);
    procedure Quitte1Click(Sender: TObject);
    procedure Importe1Click(Sender: TObject);
    procedure cDBNavigator1Insert(Sender: TObject);
    procedure cDBNavigator1Delete(Sender: TObject);
    procedure cDBNavigator1First(Sender: TObject);
    procedure cDBNavigator1Next(Sender: TObject);
    procedure cDBNavigator1Last(Sender: TObject);
    procedure Aide1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses TypFileHandle, cDBNavigator, About;

var
   nbocc: integer;

function ReplaceChar(s: string): string;
begin
     s := stringreplace(s, '', 'a', [rfreplaceall, rfignorecase]);
     s := stringreplace(s, '', 'e', [rfreplaceall, rfignorecase]);
     s := stringreplace(s, '', 'e', [rfreplaceall, rfignorecase]);
     s := stringreplace(s, '', 'e', [rfreplaceall, rfignorecase]);
     s := stringreplace(s, '', 'e', [rfreplaceall, rfignorecase]);
     s := stringreplace(s, '', 'i', [rfreplaceall, rfignorecase]);
     s := stringreplace(s, '', 'i', [rfreplaceall, rfignorecase]);
     s := stringreplace(s, '', 'o', [rfreplaceall, rfignorecase]);
     s := stringreplace(s, '', 'u', [rfreplaceall, rfignorecase]);
     s := stringreplace(s, '', 'u', [rfreplaceall, rfignorecase]);
     result := s;
end;

function factorielle(n: integer): integer;
begin
   if n = 0 then result := 0
   else result := n * factorielle(n-1);
end;

{calcule le nb de mots possibles pour un tirage de n lettres}
function NbOccurences(const n: byte): integer;
var
   i, j: byte;
   fact: integer;
begin
   result := 0;
   for i := 1 to (n-3) do begin
       fact := n;
       for j := n-1 downto i do begin
           fact := fact * j;
       end;
       result := result + fact;
   end;
end;

function Compare(List: TStringList; Index1, Index2: Integer): Integer;
var
   str1, str2: string;
begin
   str1 := List.Strings[index1];
   str2 := List.Strings[index2];
   if length(str1) > length(str2) then
      result := -1
   else
   if length(str1) < length(str2) then
      result := 1
   else
      result := 0;
end;

procedure Execute;
{type
   TmySet = set of 1..9;
   TmyArray = Array[1..9] of byte;}
var
   lenTirage: byte;
   start, LimitTime: TDateTime;
   Tirage: string[9];
   TabIndex: Array[1..9] of byte;
   IndexPris: set of 1..9;
   IndexEnCours: byte;
   Liste: TStringList;

//procedure FindWord(IndexEnCours: byte; var TabIndex: TmyArray; var IndexPris: TmySet);
procedure FindWord;

function WordInList(MotTeste: string): boolean;
var
   i: word;
begin
   if Liste.Count > 0 then
      for i := 0 to Liste.Count -1 do
          if Liste[i] = MotTeste then begin
             result := true;
             exit;
          end;
   result := false;
end;

var
   i, m: byte;
   MotTeste: String;
begin
   {teste si le temps allou n'est pas dpass}
   if ((Now - start) > LimitTime) {or (IndexEnCours > 9) }then exit;
   Form1.ProgressBar2.Position := Round((LimitTime - (Now - start))*(60*60*24));
   {m indique la position dans le mot du caractre indiqu par le nb de passage dans cette procdure}
   for m := 1 to lenTirage do
      {si la position de m n'est pas occupe par un autre caractre}
      if not (m in IndexPris) then begin
         {on indique que la position est maintenant occupe}
         IndexPris := IndexPris + [m];
         MotTeste := '';
         {on indique que TabIndex[dernire position] reoit m, index de caractre du mot trait}
         TabIndex[IndexEnCours] := m;
         if IndexEnCours > 3 then begin
            for i := 1 to IndexEnCours do
                MotTeste := MotTeste + Tirage[TabIndex[i]];
            inc(nbocc);
            Form1.ProgressBar1.Position := nbocc;
            if (findrecord(MotTeste)) and (not WordInList(MotTeste)) then begin
//            if findrecord(MotTeste) then begin
//               Form1.ListBox1.Items.Add(MotTeste);
               Liste.Add(MotTeste);
            end;
         end;
         inc(IndexEnCours);
//         FindWord(IndexEnCours+1, TabIndex, indexpris);
         FindWord;
         IndexPris := IndexPris - [m];
         dec(IndexEnCours);
      end;
end;

var
   i: byte;
begin
   start := Now;
   LimitTime := 1/(60*60*24)*(Form1.SpinEdit1.Value);
   Form1.ProgressBar2.Max := Form1.SpinEdit1.Value;
   nbocc := 0;
   Tirage := LowerCase(Form1.Edit1.Text);
   lenTirage := length(Tirage);
   Form1.ProgressBar1.Max := NbOccurences(lenTirage);
   IndexPris := [];
   IndexEnCours := 1;
   for i := 1 to 9 do
       TabIndex[i] := 0;
   Liste := TStringList.Create;
//   FindWord(1, TabIndex, IndexPris);
   FindWord;
   Liste.CustomSort(Compare);
//   Liste.Sort;
   Form1.ListBox1.Items := Liste;
   Liste.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   s: string[9];
   i: word;
begin
   screen.Cursor := crHourGlass;
   ListBox1.Clear;
   Application.ProcessMessages;
   Execute;
   screen.Cursor := crDefault;
   if ListBox1.Items.Count > 0 then begin
      s := '';
      for i := 0 to Listbox1.Items.Count -1 do
          if length(s) < length(Listbox1.Items[i]) then
             s := Listbox1.Items[i];
      showmessage('nb occurence: '+inttostr(nbocc)+#13+
                  inttostr(Form1.ListBox1.Items.Count)+' mots trouvs'+#13+
                  'mot le plus long: '+s);
   end
   else showmessage('rien trouv');
{     read(wordsfile, tmp);
     showmessage(tmp.label1[1]);}
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   s: string[9];
{type
    TVoyelle = (a, e, i, o, u, y);}
const
   Voyelle: Array[1..11] of char = ('A', 'E', 'I', 'O', 'U', 'Y',
                                    'A', 'E', 'I', 'O', 'U');
{   Consonne: Array[1..20] of char =
             ('B', 'C', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N',
              'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'X', 'Z');}
begin
//   Voyelle := ('a', 'e', 'i', 'o', 'u', 'y');
//   showmessage(inttostr(Random(5)+1));
   s := Edit1.Text+Voyelle[Random(11)+1];
   Edit1.text := s;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   s: string[9];
const
   Consonne: Array[1..50] of char =
             ('B', 'C', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N',
              'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'X', 'Z',
              'B', 'C', 'D', 'F', 'G', 'H', 'J', 'L', 'M', 'N',
              'P', 'R', 'S', 'T', 'V',
              'B', 'C', 'D', 'F', 'G', 'H', 'J', 'L', 'M', 'N',
              'P', 'R', 'S', 'T', 'V');
begin
   s := Edit1.Text+Consonne[Random(50)+1];
   Edit1.text := s;
end;

procedure TForm1.FormCreate(Sender: TObject);
{var
   cDBNavigator: TcDBNavigator;}
begin
   Randomize;
{   cDBNavigator := TcDBNavigator.Create(self);
   with cDBNavigator do begin}
   with TcDBNavigator.Create(self) do begin
      Parent := self;
      Top := 136;
      Left := 272;
      Width := 220;
      VisibleButtons := [nbFirst, nbNext, nbLast, nbInsert, nbDelete];
      OnFirst := cDBNavigator1First;
      OnNext := cDBNavigator1Next;
      OnLast := cDBNavigator1Last;
      OnInsert := cDBNavigator1Insert;
      OnDelete := cDBNavigator1Delete;
   end;
   TypFileHandle.initialize('mots.dat', 'mots.idx', 'deleted.dat');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     done;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
     if findrecord(Edit2.Text) then
        showmessage('le mot existe')
     else
        showmessage('mot inexistant');
end;

procedure TForm1.Quitte1Click(Sender: TObject);
begin
   if MessageDlg('vraiement quitter?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      Application.Terminate;
end;

procedure TForm1.Importe1Click(Sender: TObject);
var
  F1: TextFile;
  str: string[25];
  buffer: TWordsrec;
{  Present: TDateTime;}
  hr, min, sec, msec: Word;
{  start, stop, temps: integer;}
  start, stop, duration: TDateTime;
begin
  if OpenDialog1.Execute then begin
    screen.Cursor := crHourGlass;
    AssignFile(F1, OpenDialog1.Filename);
    start := Now;
{    DecodeTime(Present, hr, min, sec, msec);
    start := hr*60*60 + min*60 + sec;}
    Reset(F1);
    while not Eof(F1) do begin
       Readln(F1, str);
       if (length(str) > 3) and (length(str) < 10) then begin
          buffer.label1 := ReplaceChar(str);
          TypFileHandle.addrecord(buffer);
       end
    end;
    CloseFile(F1);
    stop := Now;
{    DecodeTime(Present, hr, min, sec, msec);
    stop := hr*60*60 + min*60 + sec;}
    duration := stop - start;
    DecodeTime(duration, hr, min, sec, msec);
    screen.Cursor := crDefault;
    showmessage('c''est fini en '+inttostr(min)+' min '+
                inttostr(sec)+' sec');
  end;
end;

procedure TForm1.cDBNavigator1Insert(Sender: TObject);
var
   rec: TWordsrec;
begin
     rec.label1 := Edit2.Text;
     TypFileHandle.addrecord(rec);
end;

procedure TForm1.cDBNavigator1Delete(Sender: TObject);
var
   rec: TWordsrec;
begin
   if MessageDlg('vraiement supprimer?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      rec.label1 := Edit2.Text;
      Deleterecord(rec);
   end;
end;

procedure TForm1.cDBNavigator1First(Sender: TObject);
var
   tmp: Tindexrec;
   tmp2: Twordsrec;
begin
     Seek(indexfile, 0);
     repeat
        read(indexfile, tmp);
        if tmp.Recordpos > -1 then begin
           seek(Wordsfile, tmp.recordpos);
           read(Wordsfile, tmp2);
        end;
{condition: rec n'est pas marqu, et rec n'est pas recordpos=-1}
     until (tmp2.label1[1] <> #4) and (tmp.Recordpos > -1);
     Edit2.Text := tmp.label1 {+' '+inttostr(tmp.recordpos)};
end;

procedure TForm1.cDBNavigator1Next(Sender: TObject);
var
   tmp: Tindexrec;
   tmp2: Twordsrec;
begin
     repeat
        read(indexfile, tmp);
        if tmp.Recordpos > -1 then begin
           seek(Wordsfile, tmp.recordpos);
           read(Wordsfile, tmp2);
        end;
{condition: rec n'est pas marqu, et rec n'est pas recordpos=-1}
     until (tmp2.label1[1] <> #4) and (tmp.Recordpos > -1);
     Edit2.Text := tmp.label1 {+' '+inttostr(tmp.recordpos)};
end;

procedure TForm1.cDBNavigator1Last(Sender: TObject);
var
   l, m: integer;
   buffer: twordsrec;
begin
     l := filesize(wordsfile);
     seek(wordsfile, l-1);
     read(wordsfile, buffer);
     m := filesize(indexfile);
     showmessage(inttostr(l)+'/'+inttostr(m));
     showmessage(buffer.label1);
end;

procedure TForm1.Aide1Click(Sender: TObject);
begin
     with TAboutBox.Create(nil) do begin
          showmodal;
          Free;
     end;
end;

end.
